/* a1.c    main for A-language
	P. Chongstitvatana
	22 Oct 2002

	start Som project   			13 Sept 2003
	som3 project					4 Nov 2004
	som v1  public release 			4 Dec 2004
*/

#include "compile.h"

#define		PRIVATE 	static

extern int tok;

FILE *FO;			// output file
int imm, def;		// list of main and defined function

PRIVATE int iMode;	// 1 interactive, 2 batch, 3 mixed

void seterror( char *mess ){
	printf("\nError line %d near '",line);
	prToken(tok);
	printf("' : %s\n",mess);
//  dumpSymTab();
	exit(-1);
}

void warning( char *mess) {
#ifdef VERBOSE
	printf("Warning line %d, %s\n",line,mess);
#endif
}

PRIVATE char *stripdot(char *source){
	static char name[80];
	char *name2;

	strcpy(name,source);
	name2 = strtok(name,".");
	if( name2 == NULL ) name2 = name;
	return name2;
}

// parse, generate and execute ex-by-ex
// accumulate parse tree in def, imm
// bmode set accumulate imm (for batch)
void evalPrint(int bmode){
	int e;
	startlex();
	lex();
	while( tok != tkEOF ){
		if( tok == tkTO ){
			top();
			e = ypop();
			// required for showparse
			// def = append(def,e);
			genex(e);
		}else {
			top();
			e = ypop();
			if( e != NIL ){
				if( bmode )
					imm = append(imm,e);
				runimm(e);
			}
		}
	}
}

void loadfile( char *fn ){
	#ifdef VERBOSE
		printf("load %s\n",fn);
	#endif
	readinfile(fn);
	evalPrint(1);	// set bmode
	freebuf();
//	dumpSymTab();
}

// read from stdin, interactive mode
void load(void){
	while(1){
		reader();
		evalPrint(0);
	}
	freebuf();
}

void listing( char *source) {
	char *list;
	list = stripdot(source);
	strcat(list,".lst");
	FO = fopen(list,"wt");
	showCode(FO);
	fclose(FO);
}

void objfile( char *source) {
	char *obj;
	obj = stripdot(source);
	strcat(obj,".obj");
	FO = fopen(obj,"wt");
	dumpSymTab(FO);
	outCode(FO);
	fclose(FO);
}

void prolog(void){
	initCharType();
	initcell();
	imm = list(newatom(OPER,tkBB));
	def = list(newatom(OPER,tkBB));
}

void showparse(void){
	printf("defined function\n");
	prlist(def);
	printf("\n");
//	dumpSymTab();
	prlist(imm);
	printf("\n");
}

/* make function main */
void epilog(void){
	int idx, e;
	idx = enterGlobal("_main",tyFUNC,0,0);
	setLv(idx,0);
}

// iMode 1 interactive, 2 batch out .obj, 3 load then interact
void run(char *source){
	prolog();
	loadfile("lib.a1");
	switch(iMode){
	case 1:
		load();
		break;
	case 2:
		loadfile(source);
		epilog();
//		showparse();
		genimm(imm);
		listing(source);
		objfile(source);
//		dumpSymTab(stdout);
		break;
	case 3:
		loadfile(source);
		load();
		break;
	}
}

void Usage(void){
	printf("%s\n%s\n%s\n%s\n",
		"som          for interactive mode",
		"som file     for batch mode, output .lst and .obj",
		"som -i file  for load file and then interact",
		"som -?       for this help");
	exit(0);
}

int main( int argc, char *argv[] ){
	char source[32];
	int i;

	iMode = 0;
	for (i=1; i<argc; i++) {
		if (argv[i][0] == '-') {
			switch (argv[i][1]) {
			case '?': Usage(); break;
			case 'i': iMode = 3; break;
			default:
				fprintf(stderr,"unknown option %s\n",argv[i]);
				exit(0);
			}
		}else
			break;   // first non option
	}
	if(argc == 1) iMode = 1;
	if(iMode == 0) iMode = 2;
	if(iMode == 2 || iMode == 3){
		// i is first non option arg
		strcpy(source,argv[i]);
	}
	run(source);
	return 0;
}

/* ============= End ============ */

